"""
This file is generated by generator/run.py based on the Chrome DevTools Protocol.


https://chromedevtools.github.io/devtools-protocol/tot/Animation/

***************************************************
                    Methods
***************************************************
"""
from __future__ import annotations

from cdpkit.protocol._types import (
    Runtime,
)
from cdpkit.protocol.base import CDPMethod, InputModel, OutputModel


class Disable(CDPMethod[None]):  # deprecated
    """ Disables animation domain notifications. """

    INPUT_VALIDATOR = None
    OUTPUT_VALIDATOR = None


class Enable(CDPMethod[None]):  # deprecated
    """ Enables animation domain notifications. """

    INPUT_VALIDATOR = None
    OUTPUT_VALIDATOR = None


class GetCurrentTimeInput(InputModel):

    id: str  # deprecated


class GetCurrentTimeOutput(OutputModel):

    currentTime: float  # deprecated


class GetCurrentTime(CDPMethod[GetCurrentTimeOutput]):  # deprecated
    """ Returns the current time of the an animation. """

    INPUT_VALIDATOR = GetCurrentTimeInput
    OUTPUT_VALIDATOR = GetCurrentTimeOutput

    def __init__(
        self,
        *,
        id_: str
    ):
        super().__init__(
            id=id_
        )


class GetPlaybackRateOutput(OutputModel):

    playbackRate: float  # deprecated


class GetPlaybackRate(CDPMethod[GetPlaybackRateOutput]):  # deprecated
    """ Gets the playback rate of the document timeline. """

    INPUT_VALIDATOR = None
    OUTPUT_VALIDATOR = GetPlaybackRateOutput


class ReleaseAnimationsInput(InputModel):

    animations: list[str]  # deprecated


class ReleaseAnimations(CDPMethod[None]):  # deprecated
    """ Releases a set of animations to no longer be manipulated. """

    INPUT_VALIDATOR = ReleaseAnimationsInput
    OUTPUT_VALIDATOR = None

    def __init__(
        self,
        *,
        animations: list[str]
    ):
        super().__init__(
            animations=animations
        )


class ResolveAnimationInput(InputModel):

    animationId: str  # deprecated


class ResolveAnimationOutput(OutputModel):

    remoteObject: Runtime.RemoteObject  # deprecated


class ResolveAnimation(CDPMethod[ResolveAnimationOutput]):  # deprecated
    """ Gets the remote object of the Animation. """

    INPUT_VALIDATOR = ResolveAnimationInput
    OUTPUT_VALIDATOR = ResolveAnimationOutput

    def __init__(
        self,
        *,
        animation_id: str
    ):
        super().__init__(
            animationId=animation_id
        )


class SeekAnimationsInput(InputModel):

    animations: list[str]  # deprecated
    currentTime: float  # deprecated


class SeekAnimations(CDPMethod[None]):  # deprecated
    """ Seek a set of animations to a particular time within each animation. """

    INPUT_VALIDATOR = SeekAnimationsInput
    OUTPUT_VALIDATOR = None

    def __init__(
        self,
        *,
        animations: list[str],
        current_time: float
    ):
        super().__init__(
            animations=animations,
            currentTime=current_time
        )


class SetPausedInput(InputModel):

    animations: list[str]  # deprecated
    paused: bool  # deprecated


class SetPaused(CDPMethod[None]):  # deprecated
    """ Sets the paused state of a set of animations. """

    INPUT_VALIDATOR = SetPausedInput
    OUTPUT_VALIDATOR = None

    def __init__(
        self,
        *,
        animations: list[str],
        paused: bool
    ):
        super().__init__(
            animations=animations,
            paused=paused
        )


class SetPlaybackRateInput(InputModel):

    playbackRate: float  # deprecated


class SetPlaybackRate(CDPMethod[None]):  # deprecated
    """ Sets the playback rate of the document timeline. """

    INPUT_VALIDATOR = SetPlaybackRateInput
    OUTPUT_VALIDATOR = None

    def __init__(
        self,
        *,
        playback_rate: float
    ):
        super().__init__(
            playbackRate=playback_rate
        )


class SetTimingInput(InputModel):

    animationId: str  # deprecated
    duration: float  # deprecated
    delay: float  # deprecated


class SetTiming(CDPMethod[None]):  # deprecated
    """ Sets the timing of an animation node. """

    INPUT_VALIDATOR = SetTimingInput
    OUTPUT_VALIDATOR = None

    def __init__(
        self,
        *,
        animation_id: str,
        duration: float,
        delay: float
    ):
        super().__init__(
            animationId=animation_id,
            duration=duration,
            delay=delay
        )
