from .events import DownloadProgress, DownloadWillBegin
from .methods import (
    AddPrivacySandboxCoordinatorKeyConfig,
    AddPrivacySandboxEnrollmentOverride,
    CancelDownload,
    Close,
    Crash,
    CrashGpuProcess,
    ExecuteBrowserCommand,
    GetBrowserCommandLine,
    GetHistogram,
    GetHistograms,
    GetVersion,
    GetWindowBounds,
    GetWindowForTarget,
    GrantPermissions,
    ResetPermissions,
    SetDockTile,
    SetDownloadBehavior,
    SetPermission,
    SetWindowBounds,
)
from .types import (
    Bounds,
    BrowserCommandId,
    BrowserContextID,
    Bucket,
    Histogram,
    PermissionDescriptor,
    PermissionSetting,
    PermissionType,
    PrivacySandboxAPI,
    WindowID,
    WindowState,
)

__all__ = [
    BrowserContextID,
    WindowID,
    WindowState,
    Bounds,
    PermissionType,
    PermissionSetting,
    PermissionDescriptor,
    BrowserCommandId,
    Bucket,
    Histogram,
    PrivacySandboxAPI,
    DownloadWillBegin,
    DownloadProgress,
    SetPermission,
    GrantPermissions,
    ResetPermissions,
    SetDownloadBehavior,
    CancelDownload,
    Close,
    Crash,
    CrashGpuProcess,
    GetVersion,
    GetBrowserCommandLine,
    GetHistograms,
    GetHistogram,
    GetWindowBounds,
    GetWindowForTarget,
    SetWindowBounds,
    SetDockTile,
    ExecuteBrowserCommand,
    AddPrivacySandboxEnrollmentOverride,
    AddPrivacySandboxCoordinatorKeyConfig,
]
