"""
This file is generated by generator/run.py based on the Chrome DevTools Protocol.


https://chromedevtools.github.io/devtools-protocol/tot/CacheStorage/

***************************************************
                    Methods
***************************************************
"""
from __future__ import annotations

from cdpkit.protocol._types import (
    CacheStorage,
    Storage,
)
from cdpkit.protocol.base import CDPMethod, InputModel, OutputModel


class DeleteCacheInput(InputModel):

    cacheId: CacheStorage.CacheId  # deprecated


class DeleteCache(CDPMethod[None]):  # deprecated
    """ Deletes a cache. """

    INPUT_VALIDATOR = DeleteCacheInput
    OUTPUT_VALIDATOR = None

    def __init__(
        self,
        *,
        cache_id: CacheStorage.CacheId
    ):
        super().__init__(
            cacheId=cache_id
        )


class DeleteEntryInput(InputModel):

    cacheId: CacheStorage.CacheId  # deprecated
    request: str  # deprecated


class DeleteEntry(CDPMethod[None]):  # deprecated
    """ Deletes a cache entry. """

    INPUT_VALIDATOR = DeleteEntryInput
    OUTPUT_VALIDATOR = None

    def __init__(
        self,
        *,
        cache_id: CacheStorage.CacheId,
        request: str
    ):
        super().__init__(
            cacheId=cache_id,
            request=request
        )


class RequestCacheNamesInput(InputModel):

    securityOrigin: str | None = None  # deprecated
    storageKey: str | None = None  # deprecated
    storageBucket: Storage.StorageBucket | None = None  # deprecated


class RequestCacheNamesOutput(OutputModel):

    caches: list[CacheStorage.Cache]  # deprecated


class RequestCacheNames(CDPMethod[RequestCacheNamesOutput]):  # deprecated
    """ Requests cache names. """

    INPUT_VALIDATOR = RequestCacheNamesInput
    OUTPUT_VALIDATOR = RequestCacheNamesOutput

    def __init__(
        self,
        *,
        security_origin: str | None = None,
        storage_key: str | None = None,
        storage_bucket: Storage.StorageBucket | None = None
    ):
        super().__init__(
            securityOrigin=security_origin,
            storageKey=storage_key,
            storageBucket=storage_bucket
        )


class RequestCachedResponseInput(InputModel):

    cacheId: CacheStorage.CacheId  # deprecated
    requestURL: str  # deprecated
    requestHeaders: list[CacheStorage.Header]  # deprecated


class RequestCachedResponseOutput(OutputModel):

    response: CacheStorage.CachedResponse  # deprecated


class RequestCachedResponse(CDPMethod[RequestCachedResponseOutput]):  # deprecated
    """ Fetches cache entry. """

    INPUT_VALIDATOR = RequestCachedResponseInput
    OUTPUT_VALIDATOR = RequestCachedResponseOutput

    def __init__(
        self,
        *,
        cache_id: CacheStorage.CacheId,
        request_url: str,
        request_headers: list[CacheStorage.Header]
    ):
        super().__init__(
            cacheId=cache_id,
            requestURL=request_url,
            requestHeaders=request_headers
        )


class RequestEntriesInput(InputModel):

    cacheId: CacheStorage.CacheId  # deprecated
    skipCount: int | None = None  # deprecated
    pageSize: int | None = None  # deprecated
    pathFilter: str | None = None  # deprecated


class RequestEntriesOutput(OutputModel):

    cacheDataEntries: list[CacheStorage.DataEntry]  # deprecated
    returnCount: float  # deprecated


class RequestEntries(CDPMethod[RequestEntriesOutput]):  # deprecated
    """ Requests data from cache. """

    INPUT_VALIDATOR = RequestEntriesInput
    OUTPUT_VALIDATOR = RequestEntriesOutput

    def __init__(
        self,
        *,
        cache_id: CacheStorage.CacheId,
        skip_count: int | None = None,
        page_size: int | None = None,
        path_filter: str | None = None
    ):
        super().__init__(
            cacheId=cache_id,
            skipCount=skip_count,
            pageSize=page_size,
            pathFilter=path_filter
        )
