"""
This file is generated by generator/run.py based on the Chrome DevTools Protocol.

Debugger domain exposes JavaScript debugging capabilities. It allows setting and removing
breakpoints, stepping through execution, exploring stack traces, etc.
https://chromedevtools.github.io/devtools-protocol/tot/Debugger/

***************************************************
                    Events
***************************************************
"""
from __future__ import annotations

from typing import Literal

from cdpkit.protocol._types import (
    Debugger,
    Runtime,
)
from cdpkit.protocol.base import JSON_DICT, CDPEvent


class BreakpointResolved(CDPEvent):
    """ Fired when breakpoint is resolved to an actual script and location.
    Deprecated in favor of `resolvedBreakpoints` in the `scriptParsed` event. """

    breakpointId: Debugger.BreakpointId  # deprecated
    location: Debugger.Location  # deprecated


class Paused(CDPEvent):
    """ Fired when the virtual machine stopped on breakpoint or exception or any other stop criteria. """

    callFrames: list[Debugger.CallFrame]  # deprecated
    reason: Literal['ambiguous', 'assert', 'CSPViolation', 'debugCommand', 'DOM', 'EventListener', 'exception', 'instrumentation', 'OOM', 'other', 'promiseRejection', 'XHR', 'step']  # deprecated
    data: JSON_DICT | None = None  # deprecated
    hitBreakpoints: list[str] | None = None  # deprecated
    asyncStackTrace: Runtime.StackTrace | None = None  # deprecated
    asyncStackTraceId: Runtime.StackTraceId | None = None  # experimental deprecated
    asyncCallStackTraceId: Runtime.StackTraceId | None = None  # experimental deprecated


class Resumed(CDPEvent):
    """ Fired when the virtual machine resumed execution. """

    ...


class ScriptFailedToParse(CDPEvent):
    """ Fired when virtual machine fails to parse the script. """

    scriptId: Runtime.ScriptId  # deprecated
    url: str  # deprecated
    startLine: int  # deprecated
    startColumn: int  # deprecated
    endLine: int  # deprecated
    endColumn: int  # deprecated
    executionContextId: Runtime.ExecutionContextId  # deprecated
    hash: str  # deprecated
    buildId: str  # deprecated
    executionContextAuxData: JSON_DICT | None = None  # deprecated
    sourceMapURL: str | None = None  # deprecated
    hasSourceURL: bool | None = None  # deprecated
    isModule: bool | None = None  # deprecated
    length: int | None = None  # deprecated
    stackTrace: Runtime.StackTrace | None = None  # experimental deprecated
    codeOffset: int | None = None  # experimental deprecated
    scriptLanguage: Debugger.ScriptLanguage | None = None  # experimental deprecated
    embedderName: str | None = None  # experimental deprecated


class ScriptParsed(CDPEvent):
    """ Fired when virtual machine parses script. This event is also fired for all known and uncollected
    scripts upon enabling debugger. """

    scriptId: Runtime.ScriptId  # deprecated
    url: str  # deprecated
    startLine: int  # deprecated
    startColumn: int  # deprecated
    endLine: int  # deprecated
    endColumn: int  # deprecated
    executionContextId: Runtime.ExecutionContextId  # deprecated
    hash: str  # deprecated
    buildId: str  # deprecated
    executionContextAuxData: JSON_DICT | None = None  # deprecated
    isLiveEdit: bool | None = None  # experimental deprecated
    sourceMapURL: str | None = None  # deprecated
    hasSourceURL: bool | None = None  # deprecated
    isModule: bool | None = None  # deprecated
    length: int | None = None  # deprecated
    stackTrace: Runtime.StackTrace | None = None  # experimental deprecated
    codeOffset: int | None = None  # experimental deprecated
    scriptLanguage: Debugger.ScriptLanguage | None = None  # experimental deprecated
    debugSymbols: list[Debugger.DebugSymbols] | None = None  # experimental deprecated
    embedderName: str | None = None  # experimental deprecated
    resolvedBreakpoints: list[Debugger.ResolvedBreakpoint] | None = None  # experimental deprecated
