"""
This file is generated by generator/run.py based on the Chrome DevTools Protocol.


https://chromedevtools.github.io/devtools-protocol/tot/Memory/

***************************************************
                    Methods
***************************************************
"""
from __future__ import annotations

from cdpkit.protocol._types import (
    Memory,
)
from cdpkit.protocol.base import CDPMethod, InputModel, OutputModel


class GetDOMCountersOutput(OutputModel):

    documents: int
    nodes: int
    jsEventListeners: int


class GetDOMCounters(CDPMethod[GetDOMCountersOutput]):  # deprecated
    """ Retruns current DOM object counters. """

    INPUT_VALIDATOR = None
    OUTPUT_VALIDATOR = GetDOMCountersOutput


class GetDOMCountersForLeakDetectionOutput(OutputModel):

    counters: list[Memory.DOMCounter]  # deprecated


class GetDOMCountersForLeakDetection(CDPMethod[GetDOMCountersForLeakDetectionOutput]):  # deprecated
    """ Retruns DOM object counters after preparing renderer for leak detection. """

    INPUT_VALIDATOR = None
    OUTPUT_VALIDATOR = GetDOMCountersForLeakDetectionOutput


class PrepareForLeakDetection(CDPMethod[None]):  # deprecated
    """ Prepares for leak detection by terminating workers, stopping spellcheckers,
    dropping non-essential internal caches, running garbage collections, etc. """

    INPUT_VALIDATOR = None
    OUTPUT_VALIDATOR = None


class ForciblyPurgeJavaScriptMemory(CDPMethod[None]):  # deprecated
    """ Simulate OomIntervention by purging V8 memory. """

    INPUT_VALIDATOR = None
    OUTPUT_VALIDATOR = None


class SetPressureNotificationsSuppressedInput(InputModel):

    suppressed: bool  # deprecated


class SetPressureNotificationsSuppressed(CDPMethod[None]):  # deprecated
    """ Enable/disable suppressing memory pressure notifications in all processes. """

    INPUT_VALIDATOR = SetPressureNotificationsSuppressedInput
    OUTPUT_VALIDATOR = None

    def __init__(
        self,
        *,
        suppressed: bool
    ):
        super().__init__(
            suppressed=suppressed
        )


class SimulatePressureNotificationInput(InputModel):

    level: Memory.PressureLevel  # deprecated


class SimulatePressureNotification(CDPMethod[None]):  # deprecated
    """ Simulate a memory pressure notification in all processes. """

    INPUT_VALIDATOR = SimulatePressureNotificationInput
    OUTPUT_VALIDATOR = None

    def __init__(
        self,
        *,
        level: Memory.PressureLevel
    ):
        super().__init__(
            level=level
        )


class StartSamplingInput(InputModel):

    samplingInterval: int | None = None  # deprecated
    suppressRandomness: bool | None = None  # deprecated


class StartSampling(CDPMethod[None]):  # deprecated
    """ Start collecting native memory profile. """

    INPUT_VALIDATOR = StartSamplingInput
    OUTPUT_VALIDATOR = None

    def __init__(
        self,
        *,
        sampling_interval: int | None = None,
        suppress_randomness: bool | None = None
    ):
        super().__init__(
            samplingInterval=sampling_interval,
            suppressRandomness=suppress_randomness
        )


class StopSampling(CDPMethod[None]):  # deprecated
    """ Stop collecting native memory profile. """

    INPUT_VALIDATOR = None
    OUTPUT_VALIDATOR = None


class GetAllTimeSamplingProfileOutput(OutputModel):

    profile: Memory.SamplingProfile


class GetAllTimeSamplingProfile(CDPMethod[GetAllTimeSamplingProfileOutput]):  # deprecated
    """ Retrieve native memory allocations profile
    collected since renderer process startup. """

    INPUT_VALIDATOR = None
    OUTPUT_VALIDATOR = GetAllTimeSamplingProfileOutput


class GetBrowserSamplingProfileOutput(OutputModel):

    profile: Memory.SamplingProfile


class GetBrowserSamplingProfile(CDPMethod[GetBrowserSamplingProfileOutput]):  # deprecated
    """ Retrieve native memory allocations profile
    collected since browser process startup. """

    INPUT_VALIDATOR = None
    OUTPUT_VALIDATOR = GetBrowserSamplingProfileOutput


class GetSamplingProfileOutput(OutputModel):

    profile: Memory.SamplingProfile


class GetSamplingProfile(CDPMethod[GetSamplingProfileOutput]):  # deprecated
    """ Retrieve native memory allocations profile collected since last
    `startSampling` call. """

    INPUT_VALIDATOR = None
    OUTPUT_VALIDATOR = GetSamplingProfileOutput
